// Auto-generated. Do not edit!

// (in-package cob_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class EmergencyStopState {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.emergency_button_stop = null;
      this.scanner_stop = null;
      this.monitoring_stop = null;
      this.user_interaction_stop = null;
      this.hardware_stop = null;
      this.bumper_stop = null;
      this.fall_stop = null;
      this.charge_stop = null;
      this.emergency_state = null;
    }
    else {
      if (initObj.hasOwnProperty('emergency_button_stop')) {
        this.emergency_button_stop = initObj.emergency_button_stop
      }
      else {
        this.emergency_button_stop = false;
      }
      if (initObj.hasOwnProperty('scanner_stop')) {
        this.scanner_stop = initObj.scanner_stop
      }
      else {
        this.scanner_stop = false;
      }
      if (initObj.hasOwnProperty('monitoring_stop')) {
        this.monitoring_stop = initObj.monitoring_stop
      }
      else {
        this.monitoring_stop = false;
      }
      if (initObj.hasOwnProperty('user_interaction_stop')) {
        this.user_interaction_stop = initObj.user_interaction_stop
      }
      else {
        this.user_interaction_stop = false;
      }
      if (initObj.hasOwnProperty('hardware_stop')) {
        this.hardware_stop = initObj.hardware_stop
      }
      else {
        this.hardware_stop = false;
      }
      if (initObj.hasOwnProperty('bumper_stop')) {
        this.bumper_stop = initObj.bumper_stop
      }
      else {
        this.bumper_stop = false;
      }
      if (initObj.hasOwnProperty('fall_stop')) {
        this.fall_stop = initObj.fall_stop
      }
      else {
        this.fall_stop = false;
      }
      if (initObj.hasOwnProperty('charge_stop')) {
        this.charge_stop = initObj.charge_stop
      }
      else {
        this.charge_stop = false;
      }
      if (initObj.hasOwnProperty('emergency_state')) {
        this.emergency_state = initObj.emergency_state
      }
      else {
        this.emergency_state = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type EmergencyStopState
    // Serialize message field [emergency_button_stop]
    bufferOffset = _serializer.bool(obj.emergency_button_stop, buffer, bufferOffset);
    // Serialize message field [scanner_stop]
    bufferOffset = _serializer.bool(obj.scanner_stop, buffer, bufferOffset);
    // Serialize message field [monitoring_stop]
    bufferOffset = _serializer.bool(obj.monitoring_stop, buffer, bufferOffset);
    // Serialize message field [user_interaction_stop]
    bufferOffset = _serializer.bool(obj.user_interaction_stop, buffer, bufferOffset);
    // Serialize message field [hardware_stop]
    bufferOffset = _serializer.bool(obj.hardware_stop, buffer, bufferOffset);
    // Serialize message field [bumper_stop]
    bufferOffset = _serializer.bool(obj.bumper_stop, buffer, bufferOffset);
    // Serialize message field [fall_stop]
    bufferOffset = _serializer.bool(obj.fall_stop, buffer, bufferOffset);
    // Serialize message field [charge_stop]
    bufferOffset = _serializer.bool(obj.charge_stop, buffer, bufferOffset);
    // Serialize message field [emergency_state]
    bufferOffset = _serializer.int16(obj.emergency_state, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type EmergencyStopState
    let len;
    let data = new EmergencyStopState(null);
    // Deserialize message field [emergency_button_stop]
    data.emergency_button_stop = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [scanner_stop]
    data.scanner_stop = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [monitoring_stop]
    data.monitoring_stop = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [user_interaction_stop]
    data.user_interaction_stop = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [hardware_stop]
    data.hardware_stop = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [bumper_stop]
    data.bumper_stop = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [fall_stop]
    data.fall_stop = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [charge_stop]
    data.charge_stop = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [emergency_state]
    data.emergency_state = _deserializer.int16(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 10;
  }

  static datatype() {
    // Returns string type for a message object
    return 'cob_msgs/EmergencyStopState';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b112a1bf6668ce1b6c95a98ca3e15cca';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This message holds the emergency stop (EMStop) status of the robot. It detects wether an EMStop is caused by the safety laserscanner or the emergency stop buttons. Moreover, it gives signalizes wether the EMStop was confirmed (after Button press stop) and the system is free again.
    
    # Possible EMStop States
    int16 EMFREE = 0            # system operatign normal
    int16 EMSTOP = 1            # emergency stop is active (Button pressed; obstacle in safety field of scanner)
    int16 EMCONFIRMED = 2       # emergency stop was confirmed system is reinitializing and going back to normal
    
    bool emergency_button_stop  # true = emergency stop signal is issued by button pressed
    bool scanner_stop           # true = emergency stop signal is issued by scanner
    bool monitoring_stop        # true = emergency stop signal is issued by monitor
    bool user_interaction_stop  # true = emergency stop signal is issued by ui
    bool hardware_stop          # true = emergency stop signal is issued due to hardware failure 
    bool bumper_stop            # true = emergency stop signal is issued by bumper
    bool fall_stop              # true = emergency stop signal is issued by fall-protecting sensors
    bool charge_stop            # true = emergency stop signal is issued due to charging process
    
    int16 emergency_state       # state (including confimation by key-switch), values see above
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new EmergencyStopState(null);
    if (msg.emergency_button_stop !== undefined) {
      resolved.emergency_button_stop = msg.emergency_button_stop;
    }
    else {
      resolved.emergency_button_stop = false
    }

    if (msg.scanner_stop !== undefined) {
      resolved.scanner_stop = msg.scanner_stop;
    }
    else {
      resolved.scanner_stop = false
    }

    if (msg.monitoring_stop !== undefined) {
      resolved.monitoring_stop = msg.monitoring_stop;
    }
    else {
      resolved.monitoring_stop = false
    }

    if (msg.user_interaction_stop !== undefined) {
      resolved.user_interaction_stop = msg.user_interaction_stop;
    }
    else {
      resolved.user_interaction_stop = false
    }

    if (msg.hardware_stop !== undefined) {
      resolved.hardware_stop = msg.hardware_stop;
    }
    else {
      resolved.hardware_stop = false
    }

    if (msg.bumper_stop !== undefined) {
      resolved.bumper_stop = msg.bumper_stop;
    }
    else {
      resolved.bumper_stop = false
    }

    if (msg.fall_stop !== undefined) {
      resolved.fall_stop = msg.fall_stop;
    }
    else {
      resolved.fall_stop = false
    }

    if (msg.charge_stop !== undefined) {
      resolved.charge_stop = msg.charge_stop;
    }
    else {
      resolved.charge_stop = false
    }

    if (msg.emergency_state !== undefined) {
      resolved.emergency_state = msg.emergency_state;
    }
    else {
      resolved.emergency_state = 0
    }

    return resolved;
    }
};

// Constants for message
EmergencyStopState.Constants = {
  EMFREE: 0,
  EMSTOP: 1,
  EMCONFIRMED: 2,
}

module.exports = EmergencyStopState;
